1   REM THIS PROGRAM IS THE EXERCISE 5.53k AT PAGE 108 OF THE ITALIAN VERSION
2   REM OF "PROGRAMMING IN BASIC" 1ST EDITION, BY BYRON S. GOTTFRIED 
10  REM NEWTON-RAPHSON ITERATION
15  ' NOTE: CUSTOMIZE THE FOLLOWING LINES AT YOUR NEED
20  E1=1E-4		' DELTA = HALF OF X MEASURE IN DERIVATIVE CALCULATION
24  E2=1E-5		' EPSILON = DISTANCE BETWEEN TWO ADJACENT RESULTS
26  N0=1E5		' ITERATIONS LIMIT
28  N1=N2=0
30  REM FNF = FUNCTION Y(X) IN X
40  DEF FNF(X)=X+COS(X)-1-SIN(X)
50  REM FND = DERIVATIVE OF ANY FUNCTION Y'(X) CONTAINED IN FNF, IN X
60  DEF FND(X)
70  	Y1=FNF(X-E1)
80	Y2=FNF(X+E1)
85	FND=(Y2-Y1)/(2*E1)
90  FNEND
100 REM SOLVE
105 PRINT "INPUT STARTING VALUE FOR X:";
110 INPUT X
115 PRINT
120 PRINT "NEWTON-RAPHSON METHOD"
130 X9=X
140 X1=X-FNF(X)/FND(X)
150 IF ABS(X1-X)<E2 THEN 200
160 X=X1
170 N1=N1+1
175 IF N1>=N0 THEN 250
180 GOTO 140
200 PRINT "SOLUTION FOUND X=";X
210 PRINT "ITERATIONS USED =";N1
230 GOTO 260
250 PRINT "NO SOLUTION FOUND AFTER";N0;"ITERATIONS"
260 STOP
300 REM FOR CONFRONTATION, THIS IS THE SUCCESSIVE SUBSTITUTIONS METHOD
302 REM TO ACTIVATE, COMMENT PREVIOUS STOP
305 PRINT
310 PRINT "SUCCESSIVE SUBSTITUTIONS METHOD"
320 X=X9		' SAME PREVIOUS INPUT
330 X1=X-FNF(X)		' F(X)=0 => (F(X)-X)+X=0 => X=X-F(X)
340 IF ABS(X1-X)<E2 THEN 400
350 X=X1
360 N2=N2+1
365 IF N2>=N0 THEN 450
370 GOTO 330
400 PRINT "SOLUTION FOUND X=";X
410 PRINT "ITERATIONS USED =";N2
430 GOTO 500
450 PRINT "NO SOLUTION FOUND AFTER";N0;"ITERATIONS"
500 END

@ The proposed function x+cos(x)=1+sin(x) has a zero for x=0, and another
for x=2.41201,
The Newton-Raphson method: if x is negative or lower than circa 1.48665 finds 
root 0 in about 15/20 iterations; if x is between 1.48665 and 2.41 finds root 
2.41 in 5/60 steps and if x is greater than 2.41 finds root 2.41 in 3/5 steps.
The Successive Substitutions method: if x is negative solves for root 0 in more 
than 400 iterations! If x is between 0 and circa 1.205, finds root 2.41 in 
around 10 steps; if x is between 1.205 and 2.41 finds root 2.41 in about 5 
iterations (the only case in which this is better), and if x is greater than 
2.41 finds root 2.41 in 3/5 steps.

The best method is the Newton-Raphson method, because it generally requires 
less steps and because it can detect all roots.

INPUT STARTING VALUE FOR X: ?-1

NEWTON-RAPHSON METHOD
SOLUTION FOUND X=-1.81929E-5 
ITERATIONS USED = 16 

SUCCESSIVE SUBSTITUTIONS METHOD
SOLUTION FOUND X=-4.46731E-3 
ITERATIONS USED = 436 

INPUT STARTING VALUE FOR X: ?.5

NEWTON-RAPHSON METHOD
SOLUTION FOUND X= 1.20737E-5 
ITERATIONS USED = 15 

SUCCESSIVE SUBSTITUTIONS METHOD
SOLUTION FOUND X= 2.41201 
ITERATIONS USED = 11 

INPUT STARTING VALUE FOR X: ?1.5

NEWTON-RAPHSON METHOD
SOLUTION FOUND X= 2.41201 
ITERATIONS USED = 56 

SUCCESSIVE SUBSTITUTIONS METHOD
SOLUTION FOUND X= 2.412 
ITERATIONS USED = 5 

INPUT STARTING VALUE FOR X: ?2.5

NEWTON-RAPHSON METHOD
SOLUTION FOUND X= 2.41201 
ITERATIONS USED = 3 

SUCCESSIVE SUBSTITUTIONS METHOD
SOLUTION FOUND X= 2.41202 
ITERATIONS USED = 4 

A note here: the Successive Substitutions method works only if there's a free
x in the function (like in the example).
But if this x is not available, like in the example 4.5, where the function

x^5+3*X^2-10=0

is transformed, taking the x out, in

x = (10-3*X^2)^(1/5)

the method cannot be used 'plainly' anymore, because it may not converge. The 
transformation, on the other hand, cannot be used 'as-is' in the Newton-Raphson 
method. 

So watch out! This method is not only cumbersome (it requires rearranging of
the function if it has no free x) but also does not lead to all results (it 
cannot always find root 0 as in the previous trigonometric example).

