/* tokens.h 
 * Copyleft (C) 2009-2014 Antonio Maschio 
 * @ <ing dot antonio dot maschio at gmail dot com>
 * Update: 16 October 2014
 *
 * This file contains the tokens arrays for all statements, useful for
 * the grace function in LIST and RESEQUENCE
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * It's GPL! Good decb!
 */

#define PECMINI 20
char* token[]= {

/* minitokens: they are the part of statements which follows the statement
 * and are syntactically necessary; the first PECMINI items are the minitokens 
 * which follow MAT/PAGE/MARGIN/QUOTE/IF; they should not receive a trailing
 * starting space, because the main toekn prints its space on its own.
 * All the other minitokens should receive a trailing space before and after */
/* 0 */	"PRINT",
/* 1 */	"INPUT",
/* 2 */	"READ",
/* 3 */	"PRINT#",
/* 4 */	"END",
/* 5 */	"ALL",
/* 6 */	"USING",
/* 7 */	"DATA",
/* 8 */	"GOTO",
/* 9 */	"",
/*10 */	"GO TO",
/*11 */	"",
/*12 */	"PAGE",
/*13 */	"QUOTE",
/*14 */	"",
/*15 */	"",
/*16 */	"",
/*17 */	"",
/*18 */	"",
/*19 */	"",
/*20 */	"",
/*21 */	"TO",
/*22 */	"STEP",
/*23 */	"BY",
/*24 */	"",
/*25 */	"THEN",
/*26 */	"", 
/*27 */	"",
/*28 */	"<>",
/*29 */	"=",
/*30 */	"",
/*31 */	"",
/*32 */	"",
/*33 */	"",
/*34 */	"",
/*35 */	"",
/*36 */	"",
/*37 */	"",
/*38 */	"",
/*39 */	"",
/*40 */	"",
/*41 */	"",
/*42 */	"",
/*43 */	"",
/*44 */	"",
/*45 */	"",
/*46 */	"",
/*47 */	"",
/*48 */	"",
/*49 */	"",
/*50 */	"",
/*51 */	"",
/*52 */	"",
/*53 */	"",
/*54 */	"",
/*55 */	"",
/*56 */	"",
/*57 */	"",
/*58 */	"", 
/*59 */	"",
/*60 */	"",
/*61 */	"",
/*62 */	"",
/*63 */	"",
/*64 */	"",
/*65 */	"",
/*66 */	"",
/*67 */	"",
/*68 */	"",
/*69 */	"",
/*70 */	"",
/*71 */	"",
/*72 */	"",
/*73 */	"",
/*74 */	"",
/*75 */	"",
/*76 */	"",
/*77 */	"",
/*78 */	"",
/*79 */	"",
/*80 */	"",
/*81 */	"",
/*82 */	"",
/*83 */	"",
/*84 */	"",
/*85 */	"",
/*86 */	"",
/*87 */	"",
/*88 */	"",
/*89 */	"",
/*90 */	"",
/*91 */	"",
/*92 */	"",
/*93 */	"",
/*94 */	"",
/*95 */	"",
/*96 */	"",
/*97 */	"",
/*98 */	"",
/*99 */	"",

/* normal tokens: they must correspond to the statements (not functions)
 * enabled in decb */
/*100*/	"",
/*101*/	"",
/*102*/	"",
/*103*/	"",
/*104*/	"",
/*105*/	"",
/*106*/	"",
/*107*/	"",
/*108*/	"", 
/*109*/	"",
/*110*/	"",
/*111*/	"",
/*112*/	"",
/*113*/	"",
/*114*/	"",
/*115*/	"",
/*116*/	"",
/*117*/	"",
/*118*/	"",
/*119*/	"",
/*120*/	"",
/*121*/	"",
/*122*/	"",
/*123*/	"",
/*124*/	"",
/*125*/	"",
/*126*/	"",
/*127*/	"",
/*128*/	"",
/*129*/	"",
/*130*/	"CHANGE",	// follows TO
/*131*/	"CHAIN",
/*132*/	"DATA",
/*133*/	"DEF",
/*134*/	"DIM",
/*135*/	"END",
/*136*/	"FILES",
/*137*/	"FILE",
/*138*/ "FNEND",
/*139*/ "FOR",		// follows TO STEP/BY
/*140*/	"GOSUB",
/*141*/ "GOTO",
/*142*/ "GO TO",
/*143*/	"GO SUB",
/*144*/	"IF",		// follows THEN/GOTO/GO TO/END
/*145*/	"",
/*146*/	"",
/*147*/	"INPUT",
/*148*/	"LET",
/*149*/	"",
/*150*/ "MARGIN",	// may follow ALL
/*151*/ "MAT",		// follow PRINT/INPUT/READ
/*152*/ "",
/*153*/ "",
/*154*/ "",
/*155*/ "",
/*156*/ "",
/*157*/ "",
/*158*/ "",
/*159*/ "",
/*160*/ "",
/*161*/ "",
/*162*/ "",
/*163*/ "", // 
/*164*/ "",
/*165*/ "",
/*166*/ "",
/*167*/ "", // 
/*168*/ "NEXT",
/*169*/ "NO",
/*170*/ "",
/*171*/ "ON",		// follows THEN/GOTO/GO TO
/*172*/ "",
/*173*/ "PAGE",		// may follow ALL
/*174*/	"PRINT",
/*175*/	"",
/*176*/	"",
/*177*/	"",
/*178*/	"",
/*179*/ "",		
/*180*/ "QUOTE",		
/*181*/ "RANDOMIZE",		
/*182*/ "",		
/*183*/ "",
/*184*/ "READ",
/*185*/ "REM",
/*186*/ "",
/*187*/ "",
/*188*/ "RESTORE",
/*189*/ "RETURN",
/*190*/ "",
/*191*/ "",
/*192*/ "SCRATCH",
/*193*/ "",
/*194*/ "SET",
/*195*/ "STOP",
/*196*/ "",
/*197*/ "",
/*198*/ "WRITE",	// may follow USING
/*199*/ "\'",		// tick comment
/*200*/ "",
/*201*/ "",
/*202*/ "",
/*203*/ "",
/*204*/ "",
/*205*/ "",
/*206*/ "",
/*207*/ "",
/*208*/ "",
/*209*/ "",
/*210*/ "",
/*211*/ "",
/*212*/ "",
/*213*/ "",
/*214*/ "",
/*215*/ "",
/*216*/ "",
/*217*/ "",
/*218*/ "",
/*219*/ "",
/*220*/ "",
/*221*/ "",
/*222*/ "",
/*223*/ "",
/*224*/ "",
/*225*/ "",
/*226*/ "",
/*227*/ "",
/*228*/ "",
/*229*/ "",
/*230*/ "",
/*231*/ "",
/*232*/ "",
/*233*/ "",
/*234*/ "",
/*235*/ "",
/*236*/ "",
/*237*/ "",
/*238*/ "",
/*239*/ "",
/*240*/ "",
/*241*/ "",
/*242*/ "",
/*243*/ "",
/*244*/ "",
/*245*/ "",
/*246*/ "",
/*247*/ "",
/*248*/ "",
/*249*/ "",
/*250*/ "",
/*251*/ "",
/*252*/ "",
/*253*/ "",
/*254*/ "",
/*255*/ "",

/*L+1*/ ""					// last + 1
};

#define TOKENLIM 256				// tokens limit
#define MINITOKENLIM 100			// minitokens limit

